Add workflows for all the direct action calls in Mistral

Bug #1640436 reported by Dougal Matthews on 2016-11-09
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
tripleo
Medium
Ryan Brady

Bug Description

We should not require the use of direct action calls. This is confusing for users and difficult to document. Understanding when you should use one and not the other requires understanding far more of the internals than we should expect from a user. This may lead to a number of workflows only calling one action (or one action + zaqar) but that will at least create a consistent interface.

We can't stop advanced users accessing actions directly, and that is okay, so long as they are willing to do this at their own risk.

Here is a case in point from #tripleo.

09:41 <tzumainn> d0ugal, hi! quick question for you - it looks like when you create a custom plan, you also need to run tripleo.templates.process and tripleo.parameters.generate_passwords - do you know if there are any other executions that need to happen?
09:42 <tzumainn> d0ugal, hm, really?
09:42 <d0ugal> tzumainn: because it does those steps.
09:42 <d0ugal> https://github.com/openstack/tripleo-common/blob/master/workbooks/plan_management.yaml#L24
09:42 <d0ugal> tzumainn: https://github.com/openstack/tripleo-common/blob/master/workbooks/plan_management.yaml#L19
09:42 <tzumainn> d0ugal, ah, I'm running the create_plan action, not the workflow
09:42 <tzumainn> I have erred greatly
09:43 <d0ugal> tzumainn: YES! You are demonstrating why I never wanted people to call actions directly
09:43 <d0ugal> tzumainn: thanks :)
09:44 <d0ugal> tzumainn: so, this is probably something I need to make clearer in the documentation.
09:44 <d0ugal> tzumainn: it is quite hard to explain, because there isn't a clear line and it isn't obvious which actions should be used directly
09:45 <tzumainn> d0ugal, I'm glad my ignorance is helpful in some weird way : )

Dougal Matthews (d0ugal) on 2016-11-09
description: updated
Dougal Matthews (d0ugal) wrote :

Needs discussion on openstack-dev

Changed in tripleo:
status: Confirmed → Opinion
status: Opinion → Incomplete
importance: High → Undecided
assignee: nobody → Dougal Matthews (d0ugal)
Changed in tripleo:
milestone: ocata-2 → ocata-3
Dougal Matthews (d0ugal) on 2016-12-16
Changed in tripleo:
importance: Undecided → Medium
Changed in tripleo:
milestone: ocata-3 → ocata-rc1
Dougal Matthews (d0ugal) on 2017-02-15
Changed in tripleo:
milestone: ocata-rc1 → pike-1
assignee: Dougal Matthews (d0ugal) → nobody
Changed in tripleo:
milestone: pike-1 → pike-2
Changed in tripleo:
milestone: pike-2 → pike-3
Changed in tripleo:
milestone: pike-3 → pike-rc1
Changed in tripleo:
milestone: pike-rc1 → queens-1
Changed in tripleo:
milestone: queens-1 → queens-2
Dougal Matthews (d0ugal) wrote :

Another motivator for this came up recently. Direct action calls are limited by the Mistral RPC timeout.

See https://launchpad.net/bugs/1719333 and https://review.openstack.org/#/c/509811/

Changed in tripleo:
milestone: queens-2 → queens-3
Changed in tripleo:
milestone: queens-3 → queens-rc1

Fix proposed to branch: master
Review: https://review.openstack.org/538953

Changed in tripleo:
assignee: nobody → Ryan Brady (rbrady)
status: Incomplete → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/543477

Fix proposed to branch: master
Review: https://review.openstack.org/546154

Changed in tripleo:
assignee: Ryan Brady (rbrady) → Brad P. Crochet (brad-9)
Changed in tripleo:
assignee: Brad P. Crochet (brad-9) → Ryan Brady (rbrady)

Reviewed: https://review.openstack.org/538953
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=20baa8524c144d5d9047e5c2ab6a7b6a10555896
Submitter: Zuul
Branch: master

commit 20baa8524c144d5d9047e5c2ab6a7b6a10555896
Author: Ryan Brady <email address hidden>
Date: Wed Jan 24 11:25:19 2018 -0500

    Adds Workflow to Delete Deployment Plan

    This patch adds a workflow to delete a deployment plan so the
    tripleo.plan.delete does not need to be called directly.

    Change-Id: Ibaf3ee800de56309e014be53e698affc358c9f5a
    Partial-Bug: 1640436

Changed in tripleo:
assignee: Ryan Brady (rbrady) → Brad P. Crochet (brad-9)
Changed in tripleo:
milestone: queens-rc1 → rocky-1
Julie Pichon (jpichon) wrote :

Adding the ui tag for awareness of the changes and the need to stop using the deprecated, direct action calls. Happy to create a separate bug if it's easier to track the work that way though!

tags: added: ui

Reviewed: https://review.openstack.org/546154
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=1f58a968f49229fec2dec0d6c6fd69d3e99c28e1
Submitter: Zuul
Branch: master

commit 1f58a968f49229fec2dec0d6c6fd69d3e99c28e1
Author: Brad P. Crochet <email address hidden>
Date: Tue Feb 20 09:06:49 2018 -0500

    Adds workflow to list deployment plans

    Create a workflow to supplant the need for a direct action call to
    list the available plans.

    Change-Id: I5eed964a31d95c46472a792b61e41fad126d7819
    Partial-Bug: #1640436

Reviewed: https://review.openstack.org/546305
Committed: https://git.openstack.org/cgit/openstack/python-tripleoclient/commit/?id=7b8646041f7e8ddbea59480f8ec8b9ad832c396d
Submitter: Zuul
Branch: master

commit 7b8646041f7e8ddbea59480f8ec8b9ad832c396d
Author: Brad P. Crochet <email address hidden>
Date: Tue Feb 20 16:09:15 2018 -0500

    Change List Plans to call workflow

    Update the client and tests to call the workflow
    tripleo.plan_management.v1.list_plans instead of the action
    tripleo.plan.action directly.

    Change-Id: I1eb47925a52dc36d063f11507a75324edf879a4e
    Depends-On: I5eed964a31d95c46472a792b61e41fad126d7819
    Partial-Bug: #1640436

Reviewed: https://review.openstack.org/539045
Committed: https://git.openstack.org/cgit/openstack/python-tripleoclient/commit/?id=af19f35b00e762c5093c205c22920a716106bc6e
Submitter: Zuul
Branch: master

commit af19f35b00e762c5093c205c22920a716106bc6e
Author: Ryan Brady <email address hidden>
Date: Mon Jan 29 18:21:36 2018 -0500

    Changes Delete Plan to Call Workflow

    This patch updates the code and associated tests to change the
    from directly calling the tripleo.plan.delete action to calling
    the tripleo.plan_management.v1.delete_deployment_plan workflow.

    Change-Id: I6d41f74f9271c17bcae67eb3c09460051f55667f
    Depends-On: Ibaf3ee800de56309e014be53e698affc358c9f5a
    Partial-Bug: 1640436

Reviewed: https://review.openstack.org/540398
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=b265e2e7b0f530be8523e69fe7b336366b5be2a4
Submitter: Zuul
Branch: master

commit b265e2e7b0f530be8523e69fe7b336366b5be2a4
Author: Ryan Brady <email address hidden>
Date: Fri Feb 2 09:28:40 2018 -0500

    Adds Update Parameters Workflow

    This patch adds a workflow to update the parameters in a given
    deployment plan so the tripleo.parameters.update action does not
    need to be called directly. This patch also makes a small change
    to the parameters.py file to mitigate a import overshadowing.

    Change-Id: I4be0edabad934db6cc203dd45be98a0a3b5fc6e0
    Partial-Bug: 1640436

Changed in tripleo:
milestone: rocky-1 → rocky-2
Ryan Brady (rbrady) wrote :

The actions referenced in this bug have either landed or have their own bug in launchpad and do not need to be tracked by this bug any longer.

Changed in tripleo:
status: In Progress → Fix Committed
Ryan Brady (rbrady) on 2018-04-24
Changed in tripleo:
status: Fix Committed → In Progress
Changed in tripleo:
assignee: Brad P. Crochet (brad-9) → Ryan Brady (rbrady)

Reviewed: https://review.openstack.org/548283
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=2c7fb29c163d4db111becc086b9e9d09ae99d0f5
Submitter: Zuul
Branch: master

commit 2c7fb29c163d4db111becc086b9e9d09ae99d0f5
Author: Brad P. Crochet <email address hidden>
Date: Tue Feb 27 13:56:24 2018 +0000

    Add workflow to generate fencing parameters

    Create a workflow to supplant the need for a direct action call to
    generate fencing parameters.

    Change-Id: I63f3a579af5aa70080f8c9cdd5eb0e8f5b3d17da
    Partial-Bug: #1640436

Reviewed: https://review.openstack.org/543477
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=471ca8c24e0344657e71709933ed790387a7cec3
Submitter: Zuul
Branch: master

commit 471ca8c24e0344657e71709933ed790387a7cec3
Author: Ryan Brady <email address hidden>
Date: Mon Feb 12 09:27:11 2018 -0500

    Add Workflow To Create Overcloudrc Files

    This patch adds a workflow to generate the overcloudrc files in a
    given deployment so the tripleo.deployment.overcloudrc action does
    not need to be called directly.

    Change-Id: I9da87beb0a3be967bad4b07c2072ccb5e1f3a6cb
    Partial-Bug: 1640436

Reviewed: https://review.openstack.org/548284
Committed: https://git.openstack.org/cgit/openstack/python-tripleoclient/commit/?id=c366263407f5b54d234cdc034140c93891636d7a
Submitter: Zuul
Branch: master

commit c366263407f5b54d234cdc034140c93891636d7a
Author: Brad P. Crochet <email address hidden>
Date: Tue Feb 27 13:57:53 2018 +0000

    Change generate fencing parameters to call workflow

    Update the client and tests to call the workflow
    tripleo.parameters.v1.generate_fencing_parameters instead of the action
    tripleo.parameters.generate_fencing directly.

    Change-Id: I9539109db4edd4b5fa2ee365cc8b3055bd2c5df7
    Depends-On: I63f3a579af5aa70080f8c9cdd5eb0e8f5b3d17da
    Partial-Bug: #1640436

Dougal Matthews (d0ugal) wrote :

It is worth noting that there are some direct action calls from instack-undercloud.

For example, I just found one here and reported a bug (about another issue related to it) https://bugs.launchpad.net/tripleo/+bug/1774185

Bogdan Dobrelya (bogdando) wrote :

There might be more, in pyhton tripleoclient undercloud installers

Changed in tripleo:
milestone: rocky-2 → rocky-3

Fix proposed to branch: master
Review: https://review.openstack.org/576126

Changed in tripleo:
assignee: Ryan Brady (rbrady) → Ana Krivokapić (akrivoka)

Reviewed: https://review.openstack.org/576126
Committed: https://git.openstack.org/cgit/openstack/tripleo-common/commit/?id=f827ee93aa1aebaea37fef28d1c7d624688faa46
Submitter: Zuul
Branch: master

commit f827ee93aa1aebaea37fef28d1c7d624688faa46
Author: Ana Krivokapic <email address hidden>
Date: Mon Jun 18 14:55:58 2018 +0200

    Add workflow for uploading validations to Swift

    Change-Id: I55be508ce5906c2f12068ae1713657eab2f658fd
    Partial-Bug: #1774185
    Partial-Bug: #1640436

Changed in tripleo:
assignee: Ana Krivokapić (akrivoka) → Ryan Brady (rbrady)

Reviewed: https://review.openstack.org/545351
Committed: https://git.openstack.org/cgit/openstack/python-tripleoclient/commit/?id=c692982bee18cb20fc8c70f153e54c5145a30205
Submitter: Zuul
Branch: master

commit c692982bee18cb20fc8c70f153e54c5145a30205
Author: Ryan Brady <email address hidden>
Date: Fri Feb 16 09:45:56 2018 -0500

    Changes Creation Of overcloudrc File to Call Workflow

    This patch updates the code and associated tests to change from
    directly calling the tripleo.deployment.overcloudrc action to
    calling the tripleo.deployment.v1.create_overcloudrc workflow.

    Change-Id: Ib100163a5c9a5d2e6cca6cbc5a186e8e5cbc19ce
    Depends-On: I6074b4085b5b77f010f5f2972e7b120aa344f6c5
    Partial-Bug: 1640436

Changed in tripleo:
milestone: rocky-3 → rocky-rc1
Changed in tripleo:
milestone: rocky-rc1 → stein-1
Changed in tripleo:
milestone: stein-1 → stein-2
Changed in tripleo:
milestone: stein-2 → stein-3
Changed in tripleo:
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related blueprints